module hex2dec(
    clk     ,
    rst_n   ,
    din_vld ,
    din     ,
    dout    ,
    dout_vld 
    );

    //
    parameter      NUM =  3;

    //źŶ
    input               clk    ;
    input               rst_n  ;
    input               din_vld;
    input [3:0]         din    ;

    //źŶ
    output[7:0]         dout   ;
    output              dout_vld  ;

    //źreg
    reg   [7:0]         dout     ;
    reg                 dout_vld ;

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout[3:0] <= 0;
        end
        else if(din>9)begin
            dout[3:0] <= din-10;
        end
        else begin
            dout[3:0] <= din;
        end
    end

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout[7:4] <= 0;
        end
        else if(din >9) begin
            dout[7:4] <= 1;
        end
        else begin
            dout[7:4] <= 0;
        end
    end


    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout_vld <= 1'b0;
        end
        else begin
            dout_vld <= din_vld;
        end
    end

endmodule

