module key_prj(
    clk    ,
    rst_n  ,
    //ź,dout
    key_col,
    key_row,
    seg_sel,
    segment 
    );
    parameter           TIME_20MS  =1000000; 
    parameter           TIME_20US  =1000   ;


    //źŶ
    input               clk    ;
    input               rst_n  ;
    input [ 3:0]        key_col;

    //źŶ
    output[ 3:0]        key_row;
    output[ 4:0]        seg_sel;
    output[ 7:0]        segment;

    //źreg
    wire  [ 3:0]        key_row;
    wire  [ 4:0]        seg_sel;
    wire  [ 7:0]        segment;

    wire  [3:0]         key_out;
    wire                key_vld;
    wire  [4*3-1:0]     cnt_dout;
    wire                cnt_dout_vld;
    wire  [7:0]         hex2dec_dout;
    wire                hex2dec_dout_vld;

    key_scan #(.TIME_20MS(TIME_20MS)) u_key_scan(
                 .clk    (clk    ),
                 .rst_n  (rst_n  ),
                 .key_col(key_col),
                 .key_row(key_row),
                 .key_out(key_out),
                 .key_vld(key_vld)   
               );

    counter#(.NUM(3)) u_counter(
                 .clk     (clk     ),
                 .rst_n   (rst_n   ),
                 .din_vld (key_vld ),
                 .dout    (cnt_dout),
                 .dout_vld(cnt_dout_vld) 
    );

    hex2dec  u_hex2dec(
                .clk     (clk     ),
                .rst_n   (rst_n   ),
                .din_vld (key_vld ),
                .din     (key_out ),
                .dout    (hex2dec_dout    ),
                .dout_vld(hex2dec_dout_vld) 
    );

   seg_disp#(.SEG_NUM(5),.TIME_20US(TIME_20US))  u_seg_disp(
                 .rst_n   (rst_n   ),
                 .clk     (clk     ),
                 .din     ({cnt_dout,hex2dec_dout}),
                 .din_vld ({{3{cnt_dout_vld}},{2{hex2dec_dout_vld}}}),
                 .seg_sel (seg_sel ),
                 .segment (segment ) 
             );
endmodule

